package com.s3ai.corporate_app2.controllers

import com.s3ai.corporate_app2.jms.persistance.*
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Controller
import org.springframework.ui.Model
import org.springframework.web.bind.annotation.*
import org.springframework.web.servlet.view.RedirectView
import java.util.*

class FilterForm {
    var actions: MutableList<JMSEntityAction> = mutableListOf()
}

@Controller
@RequestMapping("/subscription")
class SubscribersController {

    @Autowired
    lateinit var subscriberRepository: SubscribersRepository

    @Autowired
    lateinit var subTypeRepo: SubscriptionTypeRepository

    @GetMapping("/subscribe")
    fun getSubscribePage(model: Model): String? {
        val subscriber: Subscriber?
        subscriber = Subscriber()
        subscriber.id = UUID.randomUUID()
        model.addAttribute("subscriber", subscriber)
        model.addAttribute("types", JMSEntityAction.values())
        return "subscription/subscribe"
    }

    @GetMapping("/unsubscribe")
    fun getUnsubscribePage(model: Model): String {
        return "subscription/unsubscribe"
    }


    @PostMapping("/subscribe")
    fun addSubscriber(@ModelAttribute sub: Subscriber, @ModelAttribute(name = "actions") actionsForm: FilterForm, model: Model): RedirectView {
        if (actionsForm.actions.size < 1) return RedirectView("/")
        val subscriber = subscriberRepository.save(sub)
        for (action in actionsForm.actions) {
            val newType = SubscriptionType()
            newType.type = action
            newType.subscriber = subscriber
            subTypeRepo.save(newType)
        }
        return RedirectView("/")
    }

    @PostMapping("/unsubscribe")
    fun unsubscribeByEmail(@RequestParam(name = "email", required = true) email: String, model: Model): RedirectView {
        val user = subscriberRepository.findSubscriberByEmail(email)
        if (user.isPresent) {
            subscriberRepository.delete(user.get())
        }
        return RedirectView("/")
    }

}