package com.s3ai.corporate_app2.controllers;

import com.s3ai.corporate_app2.CinemaService
import com.s3ai.corporate_app2.Ticket
import com.s3ai.corporate_app2.TicketService
import com.s3ai.corporate_app2.UserService
import com.s3ai.corporate_app2.jms.JMSPublisher
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Controller
import org.springframework.ui.Model
import org.springframework.web.bind.annotation.*
import org.springframework.web.servlet.view.RedirectView
import java.util.*

@Controller
@RequestMapping("/tickets")
class TicketsController {
    @Autowired
    lateinit var ticketService: TicketService
    @Autowired
    lateinit var userService: UserService
    @Autowired
    lateinit var cinemaService: CinemaService
    @Autowired
    lateinit var publisher: JMSPublisher

    @GetMapping("/list")
    fun getTicketsBrowsePage(model: Model): String? {
        val items = getAllItems(ticketService, publisher)
        model.addAttribute("tickets", items)
        return "tickets/list"
    }

    @GetMapping("/edit")
    fun getTicketEditPage(@RequestParam(name = "id", required = false, defaultValue = "") id: String, model: Model): String? {
        val ticket: Ticket?
        if (id.isEmpty()) {
            ticket = Ticket()
            model.addAttribute("action", "Create")
        } else {
            ticket = ticketService.findById(UUID.fromString(id))
            model.addAttribute("action", "Edit")
        }
        model.addAttribute("ticket", ticket)
        model.addAttribute("users", userService.findAll())
        model.addAttribute("cinemas", cinemaService.findAll())
        return "tickets/edit"
    }

    @PostMapping("/update")
    fun updateTicket(@ModelAttribute ticket: Ticket): RedirectView {
        updateItem(ticketService, ticket, ticket.id, publisher)
        return RedirectView("/tickets/list")
    }

}
