package com.s3ai.corporate_app2.controllers.rest;

import com.s3ai.corporate_app2.User
import com.s3ai.corporate_app2.UserService
import com.s3ai.corporate_app2.controllers.deleteInstance
import com.s3ai.corporate_app2.jms.JMSPublisher
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.web.bind.annotation.*
import java.util.*
import javax.servlet.http.HttpServletResponse
import kotlin.random.Random

@RestController
@RequestMapping("/api/users")
class UserApiController {

    @Autowired
    lateinit var userService: UserService

    @Autowired
    lateinit var publisher: JMSPublisher

    @GetMapping("/fill")
    fun fillCinemas(): String? {
        val names = arrayOf("Jane", "Mary", "Paul", "Jason", "Keanu", "Andrew", "Joseph", "Jotaro", "Ivan", "Jolyne", "Walther");
        val surnames = arrayOf("Doe", "Reeves", "Statham", "Bourne", "Joestar", "Kujoh", "White", "Van Hallen", "Black", "Smith");
        val generatedNames: MutableList<String> = mutableListOf()
        for (i in 0..300) {
            val user = User();
            user.id = UUID.randomUUID();
            user.name = "${names.random()} ${surnames.random()}";
            generatedNames.add(user.name.toString())
            user.age = Random.nextInt(15, 70)

            userService.save(user);
        }
        return generatedNames.toString()
    }

    @DeleteMapping("/delete")
    fun deleteUser(@RequestParam(name = "id", required = true) id: String, response: HttpServletResponse): String? {
        return deleteInstance(id, userService, response, publisher)
    }
}
