package com.s3ai.corporate_app2.controllers.rest.json

import com.s3ai.corporate_app2.Ticket
import com.s3ai.corporate_app2.TicketService
import com.s3ai.corporate_app2.controllers.getAllItems
import com.s3ai.corporate_app2.controllers.getInstance
import com.s3ai.corporate_app2.jms.JMSPublisher
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.MediaType
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PathVariable
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController
import java.util.*
import javax.servlet.http.HttpServletResponse

@RestController
@RequestMapping("/api/json/tickets/")
class TicketsJsonController {
    @Autowired
    lateinit var ticketService: TicketService

    @Autowired
    lateinit var publisher: JMSPublisher

    @GetMapping("/all", produces = [MediaType.APPLICATION_JSON_VALUE])
    fun getTickets(response: HttpServletResponse): MutableList<Ticket> {
        return getAllItems(ticketService, publisher)
    }

    @GetMapping("/item/{id}", produces = [MediaType.APPLICATION_JSON_VALUE])
    fun getTicket(@PathVariable id: UUID, response: HttpServletResponse): Ticket? {
        return getInstance(id, ticketService, response, publisher)
    }

}