package com.s3ai.corporate_app2.controllers.rest.xslt

import com.s3ai.corporate_app2.UserService
import com.s3ai.corporate_app2.controllers.getAllItems
import com.s3ai.corporate_app2.controllers.getInstance
import com.s3ai.corporate_app2.controllers.xsltTransform
import com.s3ai.corporate_app2.jms.JMSPublisher
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.MediaType
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PathVariable
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController
import java.util.*
import javax.servlet.http.HttpServletResponse

@RestController
@RequestMapping("/api/xslt/users/")
class UsersXsltController {
    @Autowired
    lateinit var userService: UserService

    @Autowired
    lateinit var publisher: JMSPublisher

    val xsltResourceName: String = "user-process.xslt"

    @GetMapping("/all", produces = [MediaType.TEXT_HTML_VALUE])
    fun getUsers(response: HttpServletResponse): String {
        return xsltTransform(getAllItems(userService, publisher), xsltResourceName)
    }


    @GetMapping("/item/{id}", produces = [MediaType.TEXT_HTML_VALUE])
    fun getUser(@PathVariable id: UUID, response: HttpServletResponse): String? {
        val item = getInstance(id, userService, response, publisher)
        if (null != item) {
            return xsltTransform(item, xsltResourceName)
        }
        return ""
    }
}