package com.s3ai.corporate_app2

import com.fasterxml.jackson.annotation.JsonAutoDetect
import org.hibernate.annotations.OnDelete
import org.hibernate.annotations.OnDeleteAction
import java.util.*
import javax.persistence.*
import javax.xml.bind.annotation.XmlRootElement

@Entity
@Table(name = "cinema")
@XmlRootElement(name = "Cinema")
@JsonAutoDetect(fieldVisibility = JsonAutoDetect.Visibility.ANY)
class Cinema {
    @Id
    @Column(name = "ID")
    @GeneratedValue(strategy = GenerationType.AUTO)
    var id: UUID? = null

    @Column(name = "name")
    var name: String? = null

    @Column(name = "seats_count")
    var seatsCount: Int? = null

    @Column(name = "location")
    var location: String? = null

    override fun toString(): String {
        return "Cinema{id=$id, name='$name', seatsCount=$seatsCount, location='$location'}"
    }

}

@Entity
@Table(name = "cinema_user")
@JsonAutoDetect(fieldVisibility = JsonAutoDetect.Visibility.ANY)
@XmlRootElement(name = "User")
class User {
    @Id
    @Column(name = "ID")
    @GeneratedValue(strategy = GenerationType.AUTO)
    var id: UUID? = null
    @Column(name = "name")
    var name: String? = null
    @Column(name = "age")
    var age: Int? = null

    override fun toString(): String {
        return "User{id=$id, name='$name', age=$age}"
    }
}

@Entity
@Table(name = "ticket")
@JsonAutoDetect(fieldVisibility = JsonAutoDetect.Visibility.ANY)
class Ticket {
    @Id
    @Column(name = "ID")
    @GeneratedValue(strategy = GenerationType.AUTO)
    var id: UUID? = null
    @OneToOne
    @OnDelete(action = OnDeleteAction.CASCADE)
    var user: User? = null
    @OneToOne
    @OnDelete(action = OnDeleteAction.CASCADE)
    var cinema: Cinema? = null
    @Column(name = "movie")
    var movie: String? = null

    override fun toString(): String {
        return "Ticket{id=$id, user=$user, cinema=$cinema, movie='$movie'}"
    }
}