package com.s3ai.corporate_app2.jms

import org.apache.activemq.ActiveMQConnectionFactory
import org.apache.activemq.command.ActiveMQQueue
import org.springframework.beans.factory.annotation.Value
import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.Configuration
import org.springframework.jms.core.JmsTemplate
import javax.jms.Queue

@Configuration
class Config {
    @Value("\${spring.activemq.broker-url}")
    lateinit var brokerURL: String

    @Bean
    fun queue(): Queue = ActiveMQQueue("cinemas.queue")

    @Bean
    fun connectionFactory(): ActiveMQConnectionFactory {
        val factory = ActiveMQConnectionFactory()
        factory.brokerURL = brokerURL
        return factory
    }

    @Bean
    fun jmsTemplate(): JmsTemplate = JmsTemplate(connectionFactory())

}