package com.s3ai.corporate_app2.jms

import com.fasterxml.jackson.databind.ObjectMapper
import com.s3ai.corporate_app2.jms.persistance.JMSAction
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.jms.core.JmsTemplate
import org.springframework.stereotype.Component
import javax.jms.Queue

@Component
class JMSPublisher {
    @Autowired
    private lateinit var jmsTemplate: JmsTemplate


    @Autowired
    private lateinit var queue: Queue

    private final val mapper: ObjectMapper = ObjectMapper()

    fun publish(message_obj: JMSAction) {
        val messageText = mapper.writeValueAsString(message_obj)
        jmsTemplate.convertAndSend(queue, messageText)
    }
}