package com.s3ai.corporate_app2.jms.persistance

import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.Query
import org.springframework.data.repository.query.Param
import org.springframework.stereotype.Repository
import java.util.*

@Repository
interface JMSActionRepository : JpaRepository<JMSAction, UUID> {
    @Query(value = "SELECT * FROM public.jms_action WHERE delivered = FALSE", nativeQuery = true)
    fun findUndelivered(): MutableList<JMSAction>
}

@Repository
interface SubscribersRepository : JpaRepository<Subscriber, UUID> {
    @Query("FROM Subscriber WHERE email = :email")
    fun findSubscriberByEmail(@Param("email") email: String): Optional<Subscriber>
}

@Repository
interface SubscriptionTypeRepository : JpaRepository<SubscriptionType, Long> {
    @Query("FROM SubscriptionType WHERE type = :type")
    fun findSubscriptionTypeByType(@Param("type") type: JMSEntityAction): List<SubscriptionType>
}