<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

    <xsl:template match="/ArrayList">
        <table>
            <tr>
                <th class="col">UUID</th>
                <th class="col">Name</th>
                <th class="col">Seats count</th>
                <th class="col">Location</th>
            </tr>
            <xsl:apply-templates/>
        </table>
    </xsl:template>

    <xsl:template match="item">
        <tr>
            <xsl:variable name="uuid" select="string(id)"/>
            <td>
                <a href="/api/xslt/cinemas/item/{$uuid}">
                    <xsl:value-of select="string(id)"/>
                </a>
            </td>
            <td>
                <xsl:value-of select="string(name)"/>
            </td>
            <td>
                <xsl:value-of select="string(seatsCount)"/>
            </td>
            <td>
                <xsl:value-of select="string(location)"/>
            </td>
        </tr>
    </xsl:template>

    <xsl:template match="Cinema">
        <div>
            <a href="/api/xslt/cinemas/all">Go back to list</a>
        </div>
        <ul>
            <li>
                UUID:
                <xsl:value-of select="string(id)"/>
            </li>
            <li>
                Name:
                <xsl:value-of select="string(name)"/>
            </li>
            <li>
                Seats count:
                <xsl:value-of select="string(seatsCount)"/>
            </li>
            <li>
                Location:
                <xsl:value-of select="string(location)"/>
            </li>
        </ul>
    </xsl:template>

</xsl:stylesheet>