<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

    <xsl:template match="/ArrayList">
        <table>
            <tr>
                <th class="col">UUID</th>
                <th class="col">Name</th>
                <th class="col">Cinema id</th>
                <th class="col">User id</th>
            </tr>
            <xsl:apply-templates/>
        </table>
    </xsl:template>

    <xsl:template match="item">
        <tr>
            <xsl:variable name="uuid" select="string(id)"/>
            <td>
                <a href="/api/xslt/tickets/item/{$uuid}">
                    <xsl:value-of select="string(id)"/>
                </a>
            </td>
            <td>
                <xsl:value-of select="string(movie)"/>
            </td>
            <xsl:variable name="cinema_id" select="string(cinema/id)"/>
            <td>
                <a href="/api/xslt/cinemas/item/{$cinema_id}">
                    <xsl:value-of select="string(cinema/id)"/>
                </a>
            </td>
            <xsl:variable name="user_id" select="string(user/id)"/>
            <td>
                <a href="/api/xslt/users/item/{$user_id}">
                    <xsl:value-of select="string(user/id)"/>
                </a>
            </td>

        </tr>
    </xsl:template>

    <xsl:template match="Ticket">
        <div>
            <a href="/api/xslt/tickets/all">Go back to list</a>
        </div>
        <ul>
            <li>
                UUID:
                <xsl:value-of select="string(id)"/>
            </li>
            <li>
                Movie:
                <xsl:value-of select="string(movie)"/>
            </li>
            <li>
                <xsl:apply-templates select="cinema"/>
            </li>
            <li>
                <xsl:apply-templates select="user"/>
            </li>

        </ul>
    </xsl:template>

    <xsl:template match="cinema">
        <p>Cinema:</p>
        <ul>
            <xsl:variable name="uuid" select="string(id)"/>
            <li>
                ID:
                <a href="/api/xslt/cinemas/item/{$uuid}">
                    <xsl:value-of select="string(id)"/>
                </a>
            </li>
            <li>
                Name:
                <xsl:value-of select="string(name)"/>
            </li>
            <li>
                Seats count:
                <xsl:value-of select="string(seatsCount)"/>
            </li>
            <li>
                Location:
                <xsl:value-of select="string(location)"/>
            </li>
        </ul>
    </xsl:template>

    <xsl:template match="user">
        <p>User:</p>
        <ul>
            <xsl:variable name="uuid" select="string(id)"/>
            <li>
                ID:
                <a href="/api/xslt/users/item/{$uuid}">
                    <xsl:value-of select="string(id)"/>
                </a>
            </li>
            <li>
                Name: <xsl:value-of select="string(name)"/>
            </li>
            <li>
                Age: <xsl:value-of select="string(age)"/>
            </li>
        </ul>
    </xsl:template>
</xsl:stylesheet>